Loading...
Searching...
No Matches
pcl::IntensityGradientEstimation< PointInT, PointNT, PointOutT, IntensitySelectorT > Class Template Reference
Module features

IntensityGradientEstimation estimates the intensity gradient for a point cloud that contains position and intensity values. More...

`#include <pcl/features/intensity_gradient.h>`

Inheritance diagram for pcl::IntensityGradientEstimation< PointInT, PointNT, PointOutT, IntensitySelectorT >:

## Public Types

using | Ptr = shared_ptr<IntensityGradientEstimation<PointInT, PointNT, PointOutT, IntensitySelectorT> >
using | ConstPtr = shared_ptr<const IntensityGradientEstimation<PointInT, PointNT, PointOutT, IntensitySelectorT> >
using | PointCloudOut = typename Feature<PointInT, PointOutT>::PointCloudOut
Public Types inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
using | PointCloudN = pcl::PointCloud<PointNT>
using | PointCloudNPtr = typename PointCloudN::Ptr
using | PointCloudNConstPtr = typename PointCloudN::ConstPtr
using | Ptr = shared_ptr< FeatureFromNormals<PointInT, PointNT, PointOutT> >
using | ConstPtr = shared_ptr< const FeatureFromNormals<PointInT, PointNT, PointOutT> >
Public Types inherited from pcl::Feature< PointInT, PointOutT >
using | BaseClass = PCLBase<PointInT>
using | Ptr = shared_ptr< Feature<PointInT, PointOutT> >
using | ConstPtr = shared_ptr< const Feature<PointInT, PointOutT> >
using | KdTree = pcl::search::Search<PointInT>
using | KdTreePtr = typename KdTree::Ptr
using | PointCloudIn = pcl::PointCloud<PointInT>
using | PointCloudInPtr = typename PointCloudIn::Ptr
using | PointCloudInConstPtr = typename PointCloudIn::ConstPtr
using | PointCloudOut = pcl::PointCloud<PointOutT>
using | SearchMethod = std::function<int (std::size_t, double, pcl::Indices &, std::vector<float> &)>
using | SearchMethodSurface = std::function<int (const PointCloudIn &cloud, std::size_t index, double, pcl::Indices &, std::vector<float> &)>
Public Types inherited from pcl::PCLBase< PointInT >
using | PointCloud
using | PointCloudPtr
using | PointCloudConstPtr
using | PointIndicesPtr
using | PointIndicesConstPtr

## Public Member Functions

| IntensityGradientEstimation ()
| Empty constructor.
void | setNumberOfThreads (unsigned int nr_threads=0)
| Initialize the scheduler and set the number of threads to use.
Public Member Functions inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
| FeatureFromNormals ()
| Empty constructor.
void | setInputNormals (const PointCloudNConstPtr &normals)
| Provide a pointer to the input dataset that contains the point normals of the XYZ dataset.
PointCloudNConstPtr | getInputNormals () const
| Get a pointer to the normals of the input XYZ point cloud dataset.
Public Member Functions inherited from pcl::Feature< PointInT, PointOutT >
| Feature ()
| Empty constructor.
void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset.
PointCloudInConstPtr | getSearchSurface () const
| Get a pointer to the surface point cloud dataset.
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object.
KdTreePtr | getSearchMethod () const
| Get a pointer to the search method used.
double | getSearchParameter () const
| Get the internal search parameter.
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation.
int | getKSearch () const
| get the number of k nearest neighbors used for the feature estimation.
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation.
double | getRadiusSearch () const
| Get the sphere radius used for determining the neighbors.
void | compute (PointCloudOut &output)
| Base method for feature estimation for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod ().
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor.
| PCLBase (const PCLBase &base)
| Copy constructor.
virtual | ~PCLBase ()=default
| Destructor.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud.
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used.
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used.
const PointInT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Protected Member Functions

void | computeFeature (PointCloudOut &output) override
| Estimate the intensity gradients for a set of points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod ().
void | computePointIntensityGradient (const pcl::PointCloud< PointInT > &cloud, const pcl::Indices &indices, const Eigen::Vector3f &point, float mean_intensity, const Eigen::Vector3f &normal, Eigen::Vector3f &gradient)
| Estimate the intensity gradient around a given point based on its spatial neighborhood of points.
Protected Member Functions inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
virtual bool | initCompute ()
| This method should get called before starting the actual computation.
Protected Member Functions inherited from pcl::Feature< PointInT, PointOutT >
const std::string & | getClassName () const
| Get a string representation of the name of this class.
virtual bool | deinitCompute ()
| This method should get called after ending the actual computation.
int | searchForNeighbors (std::size_t index, double parameter, pcl::Indices &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface.
int | searchForNeighbors (const PointCloudIn &cloud, std::size_t index, double parameter, pcl::Indices &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface.
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation.
bool | deinitCompute ()
| This method should get called after finishing the actual computation.

## Protected Attributes

IntensitySelectorT | intensity_
| intensity field accessor structure
unsigned int | threads_ {0}
| number of threads to be used, default 0 (auto)
Protected Attributes inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
PointCloudNConstPtr | normals_
| A pointer to the input dataset that contains the point normals of the XYZ dataset.
Protected Attributes inherited from pcl::Feature< PointInT, PointOutT >
std::string | feature_name_
| The feature name.
SearchMethodSurface | search_method_surface_
| The search method template for points.
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation.
KdTreePtr | tree_
| A pointer to the spatial search object.
double | search_parameter_
| The actual search parameter (from either search_radius_ or k_).
double | search_radius_
| The nearest neighbors search radius for each point.
int | k_
| The number of K nearest neighbors to use for each point.
bool | fake_surface_
| If no surface is given, we use the input PointCloud as the surface.
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.

## Detailed Description

template<typename PointInT, typename PointNT, typename PointOutT, typename IntensitySelectorT = pcl::common::IntensityFieldAccessor<PointInT>>
class pcl::IntensityGradientEstimation< PointInT, PointNT, PointOutT, IntensitySelectorT >

IntensityGradientEstimation estimates the intensity gradient for a point cloud that contains position and intensity values.

The intensity gradient at a given point will be a vector orthogonal to the surface normal and pointing in the direction of the greatest increase in local intensity; the vector's magnitude indicates the rate of intensity change.

Author
  Michael Dixon

Definition at line 56 of file intensity_gradient.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointInT, typename PointNT, typename PointOutT, typename IntensitySelectorT = pcl::common::IntensityFieldAccessor<PointInT>>

using pcl::IntensityGradientEstimation< PointInT, PointNT, PointOutT, IntensitySelectorT >::ConstPtr = shared_ptr<const IntensityGradientEstimation<PointInT, PointNT, PointOutT, IntensitySelectorT> >

Definition at line 60 of file intensity_gradient.h.

## PointCloudOut

template<typename PointInT, typename PointNT, typename PointOutT, typename IntensitySelectorT = pcl::common::IntensityFieldAccessor<PointInT>>

using pcl::IntensityGradientEstimation< PointInT, PointNT, PointOutT, IntensitySelectorT >::PointCloudOut = typename Feature<PointInT, PointOutT>::PointCloudOut

Definition at line 69 of file intensity_gradient.h.

## Ptr

template<typename PointInT, typename PointNT, typename PointOutT, typename IntensitySelectorT = pcl::common::IntensityFieldAccessor<PointInT>>

using pcl::IntensityGradientEstimation< PointInT, PointNT, PointOutT, IntensitySelectorT >::Ptr = shared_ptr<IntensityGradientEstimation<PointInT, PointNT, PointOutT, IntensitySelectorT> >

Definition at line 59 of file intensity_gradient.h.

## Constructor & Destructor Documentation

## IntensityGradientEstimation()

template<typename PointInT, typename PointNT, typename PointOutT, typename IntensitySelectorT = pcl::common::IntensityFieldAccessor<PointInT>>

pcl::IntensityGradientEstimation< PointInT, PointNT, PointOutT, IntensitySelectorT >::IntensityGradientEstimation | ( |  | ) |

inline

Empty constructor.

Definition at line 72 of file intensity_gradient.h.

References pcl::Feature< PointInT, PointOutT >::feature_name_, and intensity_.

## Member Function Documentation

## computeFeature()

template<typename PointInT, typename PointNT, typename PointOutT, typename IntensitySelectorT>

void pcl::IntensityGradientEstimation< PointInT, PointNT, PointOutT, IntensitySelectorT >::computeFeature | ( | PointCloudOut & | output | ) |

override protected virtual

Estimate the intensity gradients for a set of points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod ().

Parameters

  output | the resultant point cloud that contains the intensity gradient vectors

Implements pcl::Feature< PointInT, PointOutT >.

Definition at line 144 of file intensity_gradient.hpp.

References computePointIntensityGradient(), pcl::PCLBase< PointInT >::indices_, intensity_, pcl::isFinite(), pcl::Feature< PointInT, PointOutT >::k_, pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >::normals_, pcl::Feature< PointInT, PointOutT >::search_parameter_, pcl::Feature< PointInT, PointOutT >::searchForNeighbors(), pcl::Feature< PointInT, PointOutT >::surface_, and threads_.

## computePointIntensityGradient()

template<typename PointInT, typename PointNT, typename PointOutT, typename IntensitySelectorT>

void pcl::IntensityGradientEstimation< PointInT, PointNT, PointOutT, IntensitySelectorT >::computePointIntensityGradient | ( | const pcl::PointCloud< PointInT > & | cloud,
|  | const pcl::Indices & | indices,
|  | const Eigen::Vector3f & | point,
|  | float | mean_intensity,
|  | const Eigen::Vector3f & | normal,
|  | Eigen::Vector3f & | gradient )

protected

Estimate the intensity gradient around a given point based on its spatial neighborhood of points.

Parameters

  cloud | a point cloud dataset containing XYZI coordinates (Cartesian coordinates + intensity)
  indices | the indices of the neighboring points in the dataset
  point | the 3D Cartesian coordinates of the point at which to estimate the gradient
  mean_intensity |
  normal | the 3D surface normal of the given point
  gradient | the resultant 3D gradient vector

Definition at line 51 of file intensity_gradient.hpp.

References pcl::eigen33(), and intensity_.

Referenced by computeFeature().

## setNumberOfThreads()

template<typename PointInT, typename PointNT, typename PointOutT, typename IntensitySelectorT = pcl::common::IntensityFieldAccessor<PointInT>>

void pcl::IntensityGradientEstimation< PointInT, PointNT, PointOutT, IntensitySelectorT >::setNumberOfThreads | ( | unsigned int | nr_threads = 0 | ) |

inline

Initialize the scheduler and set the number of threads to use.

Parameters

  nr_threads | the number of hardware threads to use (0 sets the value back to automatic)

Definition at line 81 of file intensity_gradient.h.

References threads_.

## Member Data Documentation

## intensity_

template<typename PointInT, typename PointNT, typename PointOutT, typename IntensitySelectorT = pcl::common::IntensityFieldAccessor<PointInT>>

IntensitySelectorT pcl::IntensityGradientEstimation< PointInT, PointNT, PointOutT, IntensitySelectorT >::intensity_

protected

intensity field accessor structure

Definition at line 109 of file intensity_gradient.h.

Referenced by computeFeature(), computePointIntensityGradient(), and IntensityGradientEstimation().

## threads_

template<typename PointInT, typename PointNT, typename PointOutT, typename IntensitySelectorT = pcl::common::IntensityFieldAccessor<PointInT>>

unsigned int pcl::IntensityGradientEstimation< PointInT, PointNT, PointOutT, IntensitySelectorT >::threads_ {0}

protected

number of threads to be used, default 0 (auto)

Definition at line 111 of file intensity_gradient.h.

Referenced by computeFeature(), and setNumberOfThreads().

The documentation for this class was generated from the following files:

- pcl/features/intensity_gradient.h
- pcl/features/impl/intensity_gradient.hpp